Index: /trunk/LMDZ.PLUTO/libf/phypluto/aerosol_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/aerosol_mod.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/aerosol_mod.F90	(revision 3195)
@@ -8,19 +8,14 @@
 !                 corresponding aerosol was not activated in callphys.def
 !                 -- otherwise a value is set via iniaerosol
-      integer, save, protected :: iaero_n2 = 0 
-      integer, save, protected :: iaero_dust = 0
-      integer, save, protected :: iaero_h2so4 = 0
+      integer, save :: iaero_haze = 0
+      integer, save :: i_haze = 0
       logical, save, protected :: noaero = .false.
-!$OMP THREADPRIVATE(iaero_n2,iaero_h2o,iaero_dust,iaero_h2so4,noaero)
+!$OMP THREADPRIVATE(iaero_haze,i_haze,noaero)
 
 ! two-layer simple aerosol model
       integer, save, protected :: iaero_back2lay = 0
- ! NH3 cloud
-      integer, save, protected :: iaero_nh3 = 0
 ! N-layer aerosol model (replaces the 2-layer and hard-coded clouds)
       integer,dimension(:), allocatable, save, protected :: iaero_nlay
-! Auroral aerosols
-      integer, save, protected :: iaero_aurora = 0
-!$OMP THREADPRIVATE(iaero_back2lay,iaero_nh3,iaero_nlay,iaero_aurora)
+!$OMP THREADPRIVATE(iaero_back2lay,iaero_nlay)
 
 ! Generic aerosols
@@ -33,120 +28,80 @@
 contains
 
-  SUBROUTINE iniaerosol
+  !==================================================================
+   subroutine haze_prof(ngrid,nlayer,zzlay,pplay,pt,reffrad,profmmr)
+!==================================================================
+!     Purpose
+!     -------
+!     Get fixed haze properties
+!     profile of haze (from txt file) and fixed radius profile
+!
+!==================================================================
+      use radinc_h, only: naerkind
+      use datafile_mod
+      use tracer_h
+      use comcstfi_mod, only: r, pi
 
-  use mod_phys_lmdz_para, only : is_master
-  use radinc_h, only: naerkind
-  use tracer_h, only: n_rgcs, nqtot, is_rgcs
-  use callkeys_mod, only: aeron2, dusttau, &
-                          aeroback2lay, aeronh3, nlayaero, aeronlay, &
-                          aeroaurora, aerogeneric
+!-----------------------------------------------------------------------
+!     Arguments
+      Implicit none
 
-  IMPLICIT NONE
-!=======================================================================
-!   subject:
-!   --------
-!   Initialization related to aerosols 
-!   (N2 aerosols, dust, water, chemical species, ice...)   
-!
-!   author: Laura Kerber, S. Guerlet
-!   ------
-!        
-!=======================================================================
+      integer,intent(in) :: ngrid
+      integer,intent(in) :: nlayer
+      real,intent(in) :: zzlay(ngrid,nlayer)
+      real,intent(in) :: pplay(ngrid,nlayer)
+      real,intent(in) :: pt(ngrid,nlayer)
+      real, intent(in) :: reffrad(ngrid,nlayer,naerkind)      ! haze particles radii (m)
 
-  integer :: i, ia, iq
+      real, intent(out) :: profmmr(ngrid,nlayer)              ! mmr haze kg/kg
 
-  ! Special case, dyn. allocation for n-layer depending on callphys.def
-  IF(.NOT.ALLOCATED(iaero_nlay)) ALLOCATE(iaero_nlay(nlayaero))
-  iaero_nlay(:) = 0
-  ! Do the same for iaero_generic and i_rgcs_ice
-  IF (.not. allocated(iaero_generic)) allocate(iaero_generic(aerogeneric))
-  if (.not. allocated(i_rgcs_ice)) allocate(i_rgcs_ice(aerogeneric)) 
+!     Local variables
+      integer :: iaer,l,ig,ifine
 
-  ! Init of i_rgcs_ice
-  i_rgcs_ice(:) =0
-  ia = 1
-  do iq=1,nqtot
-    if (is_rgcs(iq) .eq. 1) then 
-        i_rgcs_ice(ia)=iq
-        ia = ia+1
-     endif
-  enddo
+      LOGICAL firstcall
+      SAVE firstcall
+      DATA firstcall/.true./
 
-  iaero_generic(:)=0
-  ia=0
-  if (aeron2) then
-     ia=ia+1
-     iaero_n2=ia
-  endif
-  if (is_master) write(*,*) '--- N2 aerosol = ', iaero_n2
+      !!read altitudes and haze mmrs
+      integer Nfine
+      !parameter(Nfine=21)
+      parameter(Nfine=701)
+      character(len=100) :: file_path
+      real,save :: levdat(Nfine),densdat(Nfine)
 
-  if (dusttau.gt.0) then
-     ia=ia+1
-     iaero_dust=ia
-  endif
-  if (is_master) write(*,*) '--- Dust aerosol = ', iaero_dust
+!---------------- INPUT ------------------------------------------------
 
-     
-  if (aeroback2lay) then
-     ia=ia+1
-     iaero_back2lay=ia
-  endif
-  if (is_master) write(*,*) '--- Two-layer aerosol = ', iaero_back2lay
+      !! Read data
+      IF (firstcall) then
+        firstcall=.false.
+        file_path=trim(datadir)//'/haze_prop/hazemmr.txt'
+        open(224,file=file_path,form='formatted')
+        do ifine=1,Nfine
+           read(224,*) levdat(ifine), densdat(ifine)
+        enddo
+        close(224)
+        print*, 'TB22 read Haze MMR profile'
+      ENDIF
 
-  if (aeronh3) then
-     ia=ia+1
-     iaero_nh3=ia
-  endif
-  if (is_master) write(*,*) '--- NH3 Cloud = ', iaero_nh3
+      !! Interpolate on the model vertical grid
+      do ig=1,ngrid
+        CALL interp_line(levdat,densdat,Nfine,zzlay(ig,:)/1000.,profmmr(ig,:),nlayer)
+      enddo
 
-  if (aeronlay) then
-     do i=1,nlayaero
-       ia=ia+1
-       iaero_nlay(i)=ia
-     enddo
-  endif
-  if (is_master) write(*,*) '--- N-layer aerosol = ', iaero_nlay
+      !! Get profile Mass mixing ratio from number density:    part.cm-3 --> m-3 --> m3 m-3
+      !                                --> kg m-3 --> kg/kg
+      do iaer=1,naerkind
+            if(iaer.eq.iaero_haze.and.1.eq.2) then !TB22 activate/deactivate mmr or part density
+              !print*, 'Haze profile is fixed'
+              do ig=1,ngrid
+                 do l=1,nlayer
+                    !from number density in cm-3
+                    profmmr(ig,l)=profmmr(ig,l)*1.e6*4./3.*pi*reffrad(ig,l,iaer)**3*rho_q(i_haze)/(pplay(ig,l)/(r*pt(ig,l)))
+                 enddo
+              enddo
+            endif
+      enddo
+   end subroutine haze_prof
+!==================================================================
 
-  if (aeroaurora) then
-     ia=ia+1
-     iaero_aurora=ia
-  endif
-  if (is_master) write(*,*) '--- Auroral aerosols = ', iaero_aurora
-
-  if (aerogeneric .ne. 0) then 
-     do i=1,aerogeneric
-        ia = ia+1
-        iaero_generic(i) = ia
-     enddo
-  endif 
-      
-  if (is_master) then
-    write(*,*)'--- Radiative Generic Condensable Species = ',iaero_generic
-
-    write(*,*) '=== Number of aerosols= ', ia
-  endif ! of is_master
-
-! For the zero aerosol case, we currently make a dummy n2 aerosol which is zero everywhere.
-! (See aeropacity.F90 for how this works). A better solution would be to turn off the 
-! aerosol machinery in the no aerosol case, but this would be complicated. LK
-
-  if (ia.eq.0) then  !For the zero aerosol case. 
-     ia = 0
-     noaero = .true.
-  endif
-
-  if (.not.noaero .and. ia.ne.naerkind) then
-    if (is_master) then
-      print*, 'Aerosols counted not equal to naerkind'
-      print*, 'set correct value for nearkind in callphys.def'
-      print*, 'which should be ',ia
-      print*, 'according to current options in callphys.def'
-      print*, 'or change/correct incompatible options there'
-      print*, 'Abort in iniaerosol'
-    endif
-    call abort_physic("iniaerosl",'wrong number of aerosols',1)
-  endif ! of if (ia.ne.naerkind)
-
-  END SUBROUTINE iniaerosol
 
 end module aerosol_mod
Index: /trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90	(revision 3195)
@@ -6,5 +6,5 @@
 
       subroutine callcorrk(ngrid,nlayer,pq,nq,qsurf,           &
-          albedo,albedo_equivalent,emis,mu0,pplev,pplay,pt,    & 
+          albedo,albedo_equivalent,emis,mu0,pplev,pplay,pt,    &
           tsurf,fract,dist_star,aerosol,muvar,                 &
           dtlw,dtsw,fluxsurf_lw,                               &
@@ -26,10 +26,8 @@
       use ioipsl_getin_p_mod, only: getin_p
       use gases_h, only: ngasmx
-      use radii_mod, only : su_aer_radii,n2_reffrad,dust_reffrad,h2so4_reffrad,back2lay_reffrad
-      use aerosol_mod, only : iaero_n2,iaero_dust,iaero_h2so4, &
-                              iaero_back2lay, iaero_aurora
+      use radii_mod, only : su_aer_radii
+      use aerosol_mod, only : iaero_haze
       use aeropacity_mod, only: aeropacity
       use aeroptproperties_mod, only: aeroptproperties
-      use tracer_h, only: igcm_n2_ice
       use tracer_h, only: constants_epsi_generic
       use comcstfi_mod, only: pi, mugaz, cpp
@@ -37,5 +35,5 @@
                               diagdtau,kastprof,strictboundcorrk,specOLR, &
                               tplanckmin,tplanckmax,global1d, &
-                              generic_condensation
+                              generic_condensation, aerohaze, haze_radproffix
       use optcv_mod, only: optcv
       use optci_mod, only: optci
@@ -57,5 +55,5 @@
 !
 !     Authors
-!     ------- 
+!     -------
 !     Emmanuel 01/2001, Forget 09/2001
 !     Robin Wordsworth (2009)
@@ -65,5 +63,5 @@
 !-----------------------------------------------------------------------
 !     Declaration of the arguments (INPUT - OUTPUT) on the LMD GCM grid
-!     Layer #1 is the layer near the ground. 
+!     Layer #1 is the layer near the ground.
 !     Layer #nlayer is the layer at the top.
 !-----------------------------------------------------------------------
@@ -90,5 +88,5 @@
       logical,intent(in) :: firstcall              ! Signals first call to physics.
       logical,intent(in) :: lastcall               ! Signals last call to physics.
-      
+
       ! OUTPUT
       REAL,INTENT(OUT) :: aerosol(ngrid,nlayer,naerkind) ! Aerosol tau at reference wavelenght.
@@ -109,10 +107,10 @@
       REAL,INTENT(OUT) :: int_dtaui(ngrid,nlayer,L_NSPECTI) ! VI optical thickness of layers within narrowbands for diags ().
       REAL,INTENT(OUT) :: int_dtauv(ngrid,nlayer,L_NSPECTV) ! IR optical thickness of layers within narrowbands for diags ().
-      
-      
-      
-      
-
-! Globally varying aerosol optical properties on GCM grid ; not needed everywhere so not in radcommon_h.   
+
+
+
+
+
+! Globally varying aerosol optical properties on GCM grid ; not needed everywhere so not in radcommon_h.
 ! made "save" variables so they are allocated once in for all, not because
 ! the values need be saved from a time step to the next
@@ -208,9 +206,9 @@
       real vtmp(nlayer)
       REAL*8 muvarrad(L_LEVELS)
-      
-      ! Included by MT for albedo calculations.      
+
+      ! Included by MT for albedo calculations.
       REAL*8 albedo_temp(L_NSPECTV) ! For equivalent albedo calculation.
       REAL*8 surface_stellar_flux   ! Stellar flux reaching the surface. Useful for equivalent albedo calculation.
-     
+
       ! local variable
       integer ok ! status (returned by NetCDF functions)
@@ -254,6 +252,6 @@
           allocate(tauaero(L_LEVELS,naerkind))
         endif
-        
-        if(.not.allocated(QXVAER)) then 
+
+        if(.not.allocated(QXVAER)) then
           allocate(QXVAER(L_LEVELS,L_NSPECTV,naerkind), stat=ok)
           if (ok /= 0) then
@@ -334,6 +332,6 @@
 
          call su_aer_radii(ngrid,nlayer,reffrad,nueffrad)
-         
-         
+
+
 !--------------------------------------------------
 !             Set up correlated k
@@ -353,5 +351,5 @@
          ! call sugas_corrk       ! Set up gaseous absorption properties.
          ! call suaer_corrk       ! Set up aerosol optical properties.
-        
+
 
          ! now that L_NGAUSS has been initialized (by sugas_corrk)
@@ -435,5 +433,5 @@
          endif
 
-         
+
          if(varfixed .and. generic_condensation)then
             write(*,*) "Deep generic tracer vapor mixing ratio ? (no effect if negative) "
@@ -449,7 +447,7 @@
 
 !=======================================================================
-!          I.b  Initialization on every call   
+!          I.b  Initialization on every call
 !=======================================================================
- 
+
       qxvaer(:,:,:)=0.0
       qsvaer(:,:,:)=0.0
@@ -467,44 +465,18 @@
 !     Effective radius and variance of the aerosols
 !--------------------------------------------------
-
-      do iaer=1,naerkind
-
-         if ((iaer.eq.iaero_n2).and.tracer.and.(igcm_n2_ice.gt.0)) then ! Treat condensed n2 particles.
-            call n2_reffrad(ngrid,nlayer,nq,pq,reffrad(1,1,iaero_n2))
-
-            call planetwide_maxval(reffrad(:,:,iaero_n2),maxvalue)
-            call planetwide_minval(reffrad(:,:,iaero_n2),minvalue)
-            if (is_master) then
-              print*,'Max. N2 ice particle size = ',maxvalue/1.e-6,' um'
-               print*,'Min. N2 ice particle size = ',minvalue/1.e-6,' um'
-            end if
-         end if
-         ! Trear other aerosols here
-
-         if(iaer.eq.iaero_dust)then
-            call dust_reffrad(ngrid,nlayer,reffrad(1,1,iaero_dust))
-            if (is_master) then
-               print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
-            end if
-         endif
-         
-         if(iaer.eq.iaero_h2so4)then
-            call h2so4_reffrad(ngrid,nlayer,reffrad(1,1,iaero_h2so4))
-            if (is_master) then
-               print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
-            end if
-         endif
-         
-          if(iaer.eq.iaero_back2lay)then
-            call back2lay_reffrad(ngrid,reffrad(1,1,iaero_back2lay),nlayer,pplev)
-         endif
-
-         !  For n-layer aerosol size set once for all at firstcall in su_aer_radii
-
-!         if(iaer.eq.iaero_aurora)then
-!	    call aurora_reffrad(ngrid,nlayer,reffrad(1,1,iaero_aurora))
-!         endif
-        
-     end do !iaer=1,naerkind.
+      if (aerohaze) then
+         do iaer=1,naerkind
+            if ((iaer.eq.iaero_haze)) then
+               call su_aer_radii(ngrid,nlayer,reffrad(1,1,iaer), &
+                            nueffrad(1,1,iaer))
+            endif
+         end do !iaer=1,naerkind.
+         if (haze_radproffix) then
+            print*, 'haze_radproffix=T : fixed profile for haze rad'
+         else
+            print*,'reffrad haze:',reffrad(1,1,iaero_haze)
+            print*,'nueff haze',nueffrad(1,1,iaero_haze)
+         endif
+      endif
 
 
@@ -518,12 +490,12 @@
            QVISsQREF3d,omegaVIS3d,gVIS3d,                          &
            QIRsQREF3d,omegaIR3d,gIR3d,                             &
-           QREFvis3d,QREFir3d)                                     
+           QREFvis3d,QREFir3d)
 
       ! Get aerosol optical depths.
       call aeropacity(ngrid,nlayer,nq,pplay,pplev, pt,pq,aerosol,      &
-           reffrad,nueffrad,QREFvis3d,QREFir3d,                             & 
-           tau_col,cloudfrac,totcloudfrac,clearsky)                
- 
-!-----------------------------------------------------------------------    
+           reffrad,nueffrad,QREFvis3d,QREFir3d,                             &
+           tau_col,cloudfrac,totcloudfrac,clearsky)
+
+!-----------------------------------------------------------------------
       do ig=1,ngrid ! Starting Big Loop over every GCM column
 !-----------------------------------------------------------------------
@@ -539,10 +511,10 @@
 !    The transformation in the vertical is the same as for temperature.
 !-----------------------------------------------------------------------
-           
-           
+
+
             do iaer=1,naerkind
                ! Shortwave.
-               do nw=1,L_NSPECTV 
-               
+               do nw=1,L_NSPECTV
+
                   do l=1,nlayer
 
@@ -580,5 +552,5 @@
 
                end do ! L_NSPECTV
-             
+
                do nw=1,L_NSPECTI
                   ! Longwave
@@ -618,5 +590,5 @@
 
                end do ! L_NSPECTI
-               
+
             end do ! naerkind
 
@@ -627,5 +599,5 @@
                   do nw=1,L_NSPECTV
                      if(qsvaer(k,nw,iaer).gt.1.05*qxvaer(k,nw,iaer))then
-                        message='Serious problems with qsvaer values' 
+                        message='Serious problems with qsvaer values'
                         call abort_physic(subname,message,1)
                      endif
@@ -635,7 +607,7 @@
                   end do
 
-                  do nw=1,L_NSPECTI 
+                  do nw=1,L_NSPECTI
                      if(qsiaer(k,nw,iaer).gt.1.05*qxiaer(k,nw,iaer))then
-                        message='Serious problems with qsvaer values' 
+                        message='Serious problems with qsvaer values'
                         call abort_physic(subname,message,1)
                      endif
@@ -651,8 +623,8 @@
 !     Aerosol optical depths
 !-----------------------------------------------------------------------
-            
-         do iaer=1,naerkind     ! a bug was here           
+
+         do iaer=1,naerkind     ! a bug was here
             do k=0,nlayer-1
-               
+
                pweight=(pplay(ig,L_NLAYRAD-k)-pplev(ig,L_NLAYRAD-k+1))/   &
                        (pplev(ig,L_NLAYRAD-k)-pplev(ig,L_NLAYRAD-k+1))
@@ -667,6 +639,6 @@
             tauaero(1,iaer)          = tauaero(2,iaer)
             !tauaero(1,iaer)          = 0.
-            !JL18 at time of testing, the two above conditions gave the same results bit for bit. 
-	    
+            !JL18 at time of testing, the two above conditions gave the same results bit for bit.
+
          end do ! naerkind
 
@@ -696,5 +668,5 @@
 
             call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-            
+
             if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
 
@@ -704,6 +676,6 @@
                   do l=1,nlayer
                      qvar(2*l)   = pq(ig,nlayer+1-l,i_var)
-                     qvar(2*l+1) = pq(ig,nlayer+1-l,i_var)    
-                     !JL13index            qvar(2*l+1) = (pq(ig,nlayer+1-l,i_var)+pq(ig,max(nlayer-l,1),i_var))/2    
+                     qvar(2*l+1) = pq(ig,nlayer+1-l,i_var)
+                     !JL13index            qvar(2*l+1) = (pq(ig,nlayer+1-l,i_var)+pq(ig,max(nlayer-l,1),i_var))/2
                      !JL13index            ! Average approximation as for temperature...
                   end do
@@ -713,22 +685,22 @@
 
                   do l=1,nlayer ! Here we will assign fixed water vapour profiles globally.
-                                          
+
                      call Psat_generic(pt(ig,l),pplay(ig,l),metallicity,psat,qsat)
 
                      if (qsat .lt. qvap_deep) then
                         pq_temp(l) = qsat      ! fully saturated everywhere
-                     else 
+                     else
                         pq_temp(l) = qvap_deep
                      end if
 
                   end do
-                  
+
                   do l=1,nlayer
                      qvar(2*l)   = pq_temp(nlayer+1-l)
                      qvar(2*l+1) = (pq_temp(nlayer+1-l)+pq_temp(max(nlayer-l,1)))/2
                   end do
-                  
+
                   qvar(1)=qvar(2)
-         
+
                else
                   do k=1,L_LEVELS
@@ -739,5 +711,5 @@
             endif
 
-         end do ! do iq=1,nq loop on tracers 
+         end do ! do iq=1,nq loop on tracers
 
       end if ! if (generic_condensation)
@@ -780,8 +752,8 @@
          muvarrad(2*l+1) = (muvar(ig,nlayer+2-l)+muvar(ig,max(nlayer+1-l,1)))/2
       END DO
-   
+
       muvarrad(1) = muvarrad(2)
-      muvarrad(2*nlayer+1)=muvar(ig,1)         
-      
+      muvarrad(2*nlayer+1)=muvar(ig,1)
+
       ! Keep values inside limits for which we have radiative transfer coefficients !!!
       if(L_REFVAR.gt.1)then ! (there was a bug here)
@@ -805,17 +777,17 @@
          tlevrad(2*l+1) = (pt(ig,nlayer+1-l)+pt(ig,max(nlayer-l,1)))/2
       END DO
-      
+
       plevrad(1) = 0.
-!      plevrad(2) = 0.   !! JL18 enabling this line puts the radiative top at p=0 which was the idea before, but does not seem to perform best after all. 
-      
+!      plevrad(2) = 0.   !! JL18 enabling this line puts the radiative top at p=0 which was the idea before, but does not seem to perform best after all.
+
       tlevrad(1) = tlevrad(2)
       tlevrad(2*nlayer+1)=tsurf(ig)
-      
-      pmid(1) = pplay(ig,nlayer)/scalep   
+
+      pmid(1) = pplay(ig,nlayer)/scalep
       pmid(2) =  pmid(1)
 
       tmid(1) = tlevrad(2)
       tmid(2) = tmid(1)
-    
+
       DO l=1,L_NLAYRAD-1
          tmid(2*l+1) = tlevrad(2*l+1)
@@ -829,5 +801,5 @@
 !!Alternative interpolation:
 !         pmid(3) = pmid(1)
-!         pmid(4) = pmid(1) 
+!         pmid(4) = pmid(1)
 !         tmid(3) = tmid(1)
 !         tmid(4) = tmid(1)
@@ -870,5 +842,5 @@
             else
               print*,'***********************************************'
-              print*,'we allow model to continue with tlevrad<tgasmin' 
+              print*,'we allow model to continue with tlevrad<tgasmin'
               print*,'  ... we assume we know what you are doing ... '
               print*,'  ... but do not let this happen too often ... '
@@ -886,5 +858,5 @@
             else
               print*,'***********************************************'
-              print*,'we allow model to continue with tlevrad>tgasmax'  
+              print*,'we allow model to continue with tlevrad>tgasmax'
               print*,'  ... we assume we know what you are doing ... '
               print*,'  ... but do not let this happen too often ... '
@@ -1000,8 +972,8 @@
 
          ! Equivalent Albedo Calculation (for OUTPUT). MT2015
-         if(fract(ig) .ge. 1.0e-4) then ! equivalent albedo makes sense only during daylight.       
-            surface_stellar_flux=sum(nfluxgndv_nu(1:L_NSPECTV))      
+         if(fract(ig) .ge. 1.0e-4) then ! equivalent albedo makes sense only during daylight.
+            surface_stellar_flux=sum(nfluxgndv_nu(1:L_NSPECTV))
             if(surface_stellar_flux .gt. 1.0e-3) then ! equivalent albedo makes sense only if the stellar flux received by the surface is positive.
-               DO nw=1,L_NSPECTV                  
+               DO nw=1,L_NSPECTV
                   albedo_temp(nw)=albedo(ig,nw)*nfluxgndv_nu(nw)
                ENDDO
@@ -1025,5 +997,5 @@
 
          call sfluxi(plevrad,tlevrad,dtaui,taucumi,ubari,albi,      &
-              wnoi,dwni,cosbi,wbari,nfluxtopi,nfluxtopi_nu,         & 
+              wnoi,dwni,cosbi,wbari,nfluxtopi,nfluxtopi_nu,         &
               fmneti,fluxupi,fluxdni,fluxupi_nu,fzeroi,taugsurfi)
 
@@ -1033,5 +1005,5 @@
 
 !     Flux incident at the top of the atmosphere
-         fluxtop_dn(ig)=fluxtopvdn 
+         fluxtop_dn(ig)=fluxtopvdn
 
          fluxtop_lw(ig)  = real(nfluxtopi)
@@ -1039,6 +1011,6 @@
          fluxsurf_lw(ig) = real(fluxdni(L_NLAYRAD))
          fluxsurf_sw(ig) = real(fluxdnv(L_NLAYRAD))
-         
-!        Flux absorbed by the surface. By MT2015.         
+
+!        Flux absorbed by the surface. By MT2015.
          fluxsurfabs_sw(ig) = fluxsurf_sw(ig)*(1.-albedo_equivalent(ig))
 
@@ -1056,8 +1028,8 @@
 !     Spectral output, for exoplanet observational comparison
          if(specOLR)then
-            do nw=1,L_NSPECTI 
+            do nw=1,L_NSPECTI
                OLR_nu(ig,nw)=nfluxtopi_nu(nw)/DWNI(nw) !JL Normalize to the bandwidth
             end do
-            do nw=1,L_NSPECTV 
+            do nw=1,L_NSPECTV
                GSR_nu(ig,nw)=nfluxgndv_nu(nw)/DWNV(nw)
                OSR_nu(ig,nw)=nfluxoutv_nu(nw)/DWNV(nw) !JL Normalize to the bandwidth
@@ -1072,5 +1044,5 @@
             dtlw(ig,L_NLAYRAD+1-l)=(fmneti(l)-fmneti(l-1))  &
                 *glat(ig)/(cpp*scalep*(plevrad(2*l+1)-plevrad(2*l-1)))
-         END DO      
+         END DO
 
 !     These are values at top of atmosphere
@@ -1098,8 +1070,8 @@
           enddo
         enddo
-      endif        
-
-
-!-----------------------------------------------------------------------    
+      endif
+
+
+!-----------------------------------------------------------------------
       end do ! End of big loop over every GCM column.
 !-----------------------------------------------------------------------
@@ -1118,5 +1090,5 @@
          open(116,file='surf_vals.out')
          write(116,*) tsurf(1),pplev(1,1),fluxtop_dn(1),         &
-                      real(-nfluxtopv),real(nfluxtopi) 
+                      real(-nfluxtopv),real(nfluxtopi)
          close(116)
 
@@ -1147,7 +1119,7 @@
                write(118,*) plevrad(2*l)
                do nw=1,L_NSPECTI
-                  write(119,*) fluxupi_nu(l,nw) 
+                  write(119,*) fluxupi_nu(l,nw)
                enddo
-            enddo 
+            enddo
             close(118)
             close(119)
